//Static Shape Maps BETA 1.0
//by Wrapperup

//Video Tutorial and Tips to come.
//Allows modders to easily load static shapes.

//client.cs

exec("./SSM_Gui.cs");

function clientCmdSSM_StartMapRecieve()
{
	SSM_Selector.clear();
	
	SSM_Selector.add("None",-1);
	
	clientCmdSSM_setSelection(-1);
}

function clientCmdSSM_RecieveMap(%name, %uiName, %i)
{
	$SSM::CL::Map[%i] = %name;
	$SSM::CL::MapUIName[%i] = %uiName;
	
	SSM_addToList(%uiName, %i);
}

function SSM_addToList(%uiName, %i)
{
	if(isObject(SSM_Selector))
		SSM_Selector.add(%uiName, %i);
}

function clientCmdSSM_setSelection(%a)
{
	$SSM::CL::DisableSelect = 1;
	
	SSM_Selector.setSelected(%a);
	
	$SSM::CL::DisableSelect = 0;
}

function SSM_Selector::OnSelect()
{
	if(isObject(SSM_Selector) && !$SSM::CL::DisableSelect)
	{
		%select = SSM_Selector.getSelected();

		commandToServer('SSM_loadMap',%select);
	}
}

function SSM_showGUI(%a)
{
	if(isObject(SSM_Selector) && isObject(SSM_Text))
	{
		SSM_Selector.setVisible(%a);
		SSM_Text.setVisible(%a);
	}
}

function clientCmdSSM_AllowGUI(%a)
{
	if(%a)
	{
		SSM_showGUI(1);
		$SSM::CL::AllowedToChange = 1;
	}
	else
	{
		SSM_showGUI(0);
		$SSM::CL::AllowedToChange = 0;
	}
}

function clientCmdSSM_RecieveHandshake(%a)
{
	$SSM::CL::Handshake = true;
	if(%a)
	{
		commandToServer('SSM_RequestMapList');
		commandToServer('SSM_ReqCurrentMap');
		clientCmdSSM_AllowGUI(1);
	}
	else
	{
		echo("SSM: Handshake was made, but insufficient priviledges.");
		clientCmdSSM_AllowGUI(0);
	}
}

function SSM_RevertPrefs()
{
	clientCmdSSM_AllowGUI(0);
	
	$SSM::CL::Handshake = 0;
	$SSM::CL::NeedsMapList = 0;
}

package SSM_Client
{
	function EnvGui::onWake(%this)
	{
		parent::onWake(%this);
		
		if(!$SSM::CL::Handshake)
		{
			clientCmdSSM_showGUI(0);
			
			commandToServer('SSM_Handshake');
			return;
		}
		
		commandToServer('SSM_ReqCurrentMap');
		
		if(!$SSM::CL::AllowedToChange)
		{
			clientCmdSSM_ShowGUI(0);
			return;
		}
		
		if($SSM::CL::NeedsMapList)
		{
			$SSM::CL::NeedsMapList = 1;
			commandToServer('SSM_RequestMapList');
		}
	}
	
	function disconnectedCleanup(%bool)
	{
		parent::disconnectedCleanup(%bool);
		SSM_RevertPrefs();
	}
	
	function clientCmdSetAdminLevel(%a)
	{
		parent::clientCmdSetAdminLevel(%a);
		
		if(%a == 2)
			clientCmdSSM_AllowGUI(1);
	}
};

activatePackage(SSM_Client);
